#!/bin/bash

cfgfile=/etc/router/config/storage_delete_volume.json
datadir=`cat ${cfgfile} | jq -r .name`
dev_path=`cat ${cfgfile} | jq -r .path`

# umount datadir
mount_points=`df | awk '{print $6}' | grep "^${datadir}"`
if [[ -n ${mount_points} ]]; then
	umount ${datadir}
	if [[ $? != 0 ]]; then
		fuser -kmv ${datadir}
		umount ${datadir}
		if [[ $? != 0 ]]; then
			echo "Could not umount ${datadir}..." >&2
			exit 1
		fi
	fi
fi

# delete mount config
sed -i "\#  ${datadir}  #d" /etc/fstab

# stop raid device
mdadm -D ${dev_path}
if [[ $? == 0 ]]; then
	mdadm -S ${dev_path}
fi