local router = require("router")

local function try_kod_access(token)
	local cjson = require("cjson")

	res = ngx.location.capture("/kodinfo",{
		method = ngx.HTTP_GET,
		args = {accessToken=token}
	});
	if (200 ~= res.status) then
		ngx.status = ngx.HTTP_UNAUTHORIZED
		router.process_error(1, "Route-Token is invalid!")
		return -1
	end

	local kod_data = cjson.decode(res.body)
	if (kod_data["data"]["user"] == nil) then
		ngx.status = ngx.HTTP_UNAUTHORIZED
		router.process_error(1, "Route-Token is invalid!")
		return -1
	end

	if (kod_data["data"]["user"]["isRoot"] == 0) then
		ngx.status = ngx.HTTP_FORBIDDEN
		router.process_error(1, "user is not administrator!")
		return -1
	end

	return 0
end

local headers = ngx.req.get_headers()
if headers["Route-Token"] then
	local cjson = require("cjson")
	local file = io.open("/etc/router/config/user_info.json", "r");
	if (file == nil) then
		ngx.status = ngx.HTTP_UNAUTHORIZED
		router.process_error(1, "access: read file failed!")
		return
	end

	local file_data = file:read("*a");
	file:close()
	local user = cjson.decode(file_data)
	local token = ngx.md5(user["username"]..":"..user["password"])
	if (headers["Route-Token"] ~= token) then
		try_kod_access(headers["Route-Token"])
	end
else
	ngx.status = ngx.HTTP_UNAUTHORIZED
	router.process_error(1, "Route-Token is nil!")
end
