local router = require("router")

local function try_kod_login(req)
	local cjson = require("cjson")
	local res = ngx.location.capture("/kodlogin", {
		method = ngx.HTTP_GET,
		args = {name=req["username"], password=req["password"]}
	});
	if (200 ~= res.status) then
		router.process_error(1, "user name or password is incorrect!")
		return -1
	end

	local body_data = cjson.decode(res.body)
	if (body_data["code"] == false) then
		router.process_error(1, "user name or password is incorrect!")
		return -1
	end

	res = ngx.location.capture("/kodinfo", {
		method = ngx.HTTP_GET,
		args = {accessToken=body_data["info"]}
	});
	if (200 ~= res.status) then
		router.process_error(1, "user name or password is incorrect!")
		return -1
	end

	local kod_data = cjson.decode(res.body)
	if (kod_data["data"]["user"]["isRoot"] == 0) then
		router.process_error(1, "user is not administrator!")
		return -1
	end

	local temp = {}
	temp["err_code"] = 0
	temp["err_info"] = "ok"
	temp["token"] = body_data["info"]
	local resp = cjson.encode(temp)
	ngx.say(resp)
	return 0
end

local file = io.open("/etc/router/config/user_info.json", "r");
if (file == nil) then
	router.process_error(1, "user_login: open file failed!")
	return
end
local file_data = file:read("*a");
file:close()
local cjson = require("cjson")
local user = cjson.decode(file_data)
local body_data = ngx.req.get_body_data()
local req = cjson.decode(body_data)
if (user["username"] == req["username"] and user["password"] == req["password"]) then
	local temp = {}
	temp["err_code"] = 0
	temp["err_info"] = "ok"
	temp["token"] = ngx.md5(user["username"]..":"..user["password"])
	local resp = cjson.encode(temp)
	ngx.say(resp)
else
	try_kod_login(req)
end
